"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pass = exports.unless = exports.when = void 0;
function when(F) {
    return b => x => (b ? x : F.of(undefined));
}
exports.when = when;
function unless(F) {
    return b => x => (b ? F.of(undefined) : x);
}
exports.unless = unless;
function pass(F) {
    return F.of(undefined);
}
exports.pass = pass;
