import * as IOO from "fp-ts/IOOption";
import * as IO from "fp-ts/IO";
import { flow } from "fp-ts/function";
import { pass as _pass } from "./Applicative";
import { execute as executeIO } from "./IO";
import { unsafeExpect as unsafeExpectO, unsafeUnwrap as unsafeUnwrapO, } from "./Option";
export const unsafeUnwrap = flow(IO.map(unsafeUnwrapO), executeIO);
export const unsafeExpect = (msg) => flow(IO.map(unsafeExpectO(msg)), executeIO);
export const pass = _pass(IOO.Applicative);
