"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pass = exports.unsafeExpect = exports.unsafeUnwrap = void 0;
const IOO = require("fp-ts/IOOption");
const IO = require("fp-ts/IO");
const function_1 = require("fp-ts/function");
const Applicative_1 = require("./Applicative");
const IO_1 = require("./IO");
const Option_1 = require("./Option");
exports.unsafeUnwrap = (0, function_1.flow)(IO.map(Option_1.unsafeUnwrap), IO_1.execute);
const unsafeExpect = (msg) => (0, function_1.flow)(IO.map((0, Option_1.unsafeExpect)(msg)), IO_1.execute);
exports.unsafeExpect = unsafeExpect;
exports.pass = (0, Applicative_1.pass)(IOO.Applicative);
