"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.nonePass = exports.anyPass = exports.allPass = void 0;
const Monoid_1 = require("fp-ts/Monoid");
const Pred = require("fp-ts/Predicate");
const function_1 = require("fp-ts/function");
const Boolean_1 = require("./Boolean");
const allPass = (fs) => (0, Monoid_1.concatAll)(Pred.getMonoidAll())(fs);
exports.allPass = allPass;
const anyPass = (fs) => (0, Monoid_1.concatAll)(Pred.getMonoidAny())(fs);
exports.anyPass = anyPass;
const nonePass = (fs) => (0, function_1.flow)((0, exports.anyPass)(fs), Boolean_1.invert);
exports.nonePass = nonePass;
