"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pass = exports.unsafeExpect = exports.unsafeUnwrap = void 0;
const TO = require("fp-ts/TaskOption");
const T = require("fp-ts/Task");
const function_1 = require("fp-ts/function");
const Applicative_1 = require("./Applicative");
const Option_1 = require("./Option");
const Task_1 = require("./Task");
exports.unsafeUnwrap = (0, function_1.flow)(T.map(Option_1.unsafeUnwrap), Task_1.execute);
const unsafeExpect = (msg) => (0, function_1.flow)(T.map((0, Option_1.unsafeExpect)(msg)), Task_1.execute);
exports.unsafeExpect = unsafeExpect;
exports.pass = (0, Applicative_1.pass)(TO.ApplicativePar);
