import * as TO from "fp-ts/TaskOption";
import * as T from "fp-ts/Task";
import { flow } from "fp-ts/function";
import { pass as _pass } from "./Applicative";
import { unsafeExpect as unsafeExpectO, unsafeUnwrap as unsafeUnwrapO, } from "./Option";
import { execute as executeT } from "./Task";
export const unsafeUnwrap = flow(T.map(unsafeUnwrapO), executeT);
export const unsafeExpect = (msg) => flow(T.map(unsafeExpectO(msg)), executeT);
export const pass = _pass(TO.ApplicativePar);
